---
title: Allocations
slug: Tools/Performance/Allocations
---
<div>{{ToolsSidebar}}</div><div class="summary">
<p>The Allocations view in the Performance tool shows you which functions in your page are allocating the most memory over the course of the profile.</p>

<p>For performance this is important mostly because allocating a lot of memory, or making a lot of allocations, can trigger <a href="/en-US/docs/Tools/Performance/Allocations#Allocations_and_garbage_collection">garbage collection</a>. This in turn can hurt the responsiveness of a page.</p>
</div>

<div class="geckoVersionNote">
<p>The Allocations view is new in Firefox 46.</p>
</div>

<p>To enable the Allocations view, you must check "Record Allocations" in the Performance tool settings, <em>before</em> recording a profile. Then <a href="/en-US/docs/Tools/Performance/How_to#Record_a_profile">record a profile</a> as usual, and you will see a new tab labeled "Allocations" in the toolbar:</p>

<p>{{EmbedYouTube("Le9tTo7bqts")}}</p>

<h2 id="Anatomy_of_the_allocations_view">Anatomy of the allocations view</h2>

<p>The allocations view looks something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12393/allocations-view-1.png" style="display: block; height: 156px; margin-left: auto; margin-right: auto; width: 900px;"></p>

<p>The allocations view periodically samples allocations that are made over the recording. Each row represents a function in which at least one allocation-sample was taken during the recording.</p>

<p>It includes the following columns:</p>

<ul>
 <li>Self Count: the number of allocation-samples that were taken in this function (also shown as a percentage of the total)</li>
 <li>Self Bytes: the total number of bytes allocated in the allocation-samples in this function (also shown as a percentage of the total)</li>
</ul>

<p>Rows are sorted by the "Self Bytes" column.</p>

<p>So in the example above:</p>

<ul>
 <li>8904 samples were taken in <code>signalLater()</code>, which is 28.57% of the total number of samples taken</li>
 <li>those samples allocated 1102888 bytes, which is 30.01% of the total memory allocated in all samples</li>
</ul>

<p>Next to each function name is a disclosure arrow. Click this to see the places this function was called from:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12397/allocations-view-2.png" style="display: block; height: 155px; margin-left: auto; margin-right: auto; width: 900px;"></p>

<p>Here you can see that <code>signalLater()</code> was called from two places: <code>removeInner()</code> and <code>setSelectionInner()</code>. In this way you can walk back up the call stack, and understand better the context for these allocations.</p>

<h3 id="Self_Cost_and_Total_Cost">Self Cost and Total Cost</h3>

<ul>
</ul>

<p>You'll see that there are separate sets of columns for "Self" and for "Total". "Self" records samples taken only in this function. "Total" records samples taken in this function or in functions called by this function. At the top level, these are always the same, since the view presents "leaf" functions at the top level (that is, it presents an inverted view of the call stack). But if you start walking back up the call stack, you'll see the difference:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12397/allocations-view-2.png" style="display: block; height: 155px; margin-left: auto; margin-right: auto; width: 900px;"></p>

<p>Here, 8904 samples were taken in <code>signalLater()</code>. But <code>signalLater()</code> was called from two places: <code>removeInner()</code> and <code>setSelectionInner()</code>. Both these functions have 0 in Self Count, meaning that no allocations were seen directly in these functions. However, <code>removeInner()</code> has 8901 in Total Count, while <code>setSelectionInner()</code> has just 3 in Total Count. This is telling us that, of the 8904 allocations seen in <code>signalLater()</code>, all but three came through the <code>removeInner()</code> branch.</p>

<h2 id="Allocations_and_garbage_collection">Allocations and garbage collection</h2>

<p>Of course, the memory allocated by a site is in itself useful information to know. But the main connection between the allocation profile of a site and its responsiveness is the cost of garbage collection (GC).</p>

<p>With a garbage-collected language, like JavaScript, the runtime periodically needs to walk the heap looking for objects that are no longer <a href="/en-US/docs/Tools/Memory/Dominators#Reachability">reachable</a>, and then freeing the memory they occupy. While GC events like this are executing, the JavaScript engine must be paused, so your program is suspended and will be completely unresponsive.</p>

<p>To reduce the impact on responsiveness, <a href="/en-US/docs/Mozilla/Projects/SpiderMonkey">SpiderMonkey</a> (the JavaScript engine in Firefox) can perform GC in small increments, letting the program run in between. Sometimes, though, it needs to perform a full non-incremental collection, and the program has to wait for it to finish.</p>

<p>GC events are shown as red markers in the <a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a> view, and are a big red flag for responsiveness,  sometimes running for hundreds of milliseconds:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/12399/allocations-view-long-gc.png" style="display: block; height: 160px; margin-left: auto; margin-right: auto; width: 900px;"></p>

<p>If you're seeing GC events in your site's performance profile, what can you do? SpiderMonkey uses a <a href="https://dxr.mozilla.org/mozilla-central/rev/584870f1cbc5d060a57e147ce249f736956e2b62/js/src/gc/GCRuntime.h#192">complex set of heuristics</a> to decide when to do what sort of garbage collection.</p>

<p>In general, though:<em> allocation pressure - allocating a lot of memory, or allocating memory at a high rate - makes SpiderMonkey more likely to run garbage collection, and more likely to run full, non-incremental garbage collection.</em></p>

<p>If a GC event was caused by allocation pressure, then the sidebar on the right of the marker in the Waterfall view contains a link labeled "Show allocation triggers". If you click this link, the devtools switches to the allocations view, and selects the region of time from the end of the last GC cycle to the start of the one you clicked on. This shows you all the allocations that collectively triggered this GC event:</p>

<p>{{EmbedYouTube("tO5ovD9Jw4k")}}</p>

<p>If you're seeing these problems, consider whether you can reduce the number or size of the allocations you're making here. For example:</p>

<ul>
 <li>can you allocate memory lazily, when it is actually needed, instead of up front?</li>
 <li>if allocating memory in a loop, can you reuse a single allocation in every loop iteration?</li>
</ul>
